require "rake-chef-syntax/version"

namespace :chef do
  desc "Run knife cookbook test to validate syntax of cookbooks"
  task :syntax_check do
    puts "Running knife cookbook test ... "
    with_knife_rb do |knife_rb|
      if File.exists?('cookbooks')
        sh "knife cookbook test -c #{knife_rb} -a -o cookbooks/"
      else
        sh "knife cookbook test -c #{knife_rb} -a -o ."
      end
    end
    puts "knife cookbook test FINISHED."
  end 

  def with_knife_rb
    knife_rb = "tests/knife.rb"
    cachedir = "tests/knife_test_checksums"

    begin
      rm_rf cachedir
      mkdir_p cachedir
      open(knife_rb, 'w') do |f|
        f.write <<-EOS
          cache_type 'BasicFile'
          cache_options(:path => "#{ENV['HOME']}/.chef/checksums")
        EOS
      end
      yield knife_rb
    ensure
      rm_rf knife_rb
      rm_rf cachedir
    end
  end
end
